Attribute VB_Name = "MainModule"
' OpenWithVim, version 1.0

' Author: Christian Schaller (sca@isogmbh.de)

' Description: opens given file with Vim (if exists, otherwise Vim is
' started first) and jumps to given line number, if supplied.

' Requires: GVim 5.3 with OLE support

' Examples:
' edit MyFile with vim:
'   OpenWithVim MyFile
' edit MyFile with vim and jump to line number 20
'   OpenWithVim +20 MyFile

Sub Main()
    Dim usage As String
    Dim length As Integer
    Dim commandline As Variant
    Dim path As String
    Dim vim As Object
    Dim line As String
    Dim file As String
    
    line = ""
    file = ""
    
    usage = "OpenWithVim 1.0 (19.III.99)" _
        & vbCrLf _
        & vbCrLf & "Usage: OpenWithVim [+<line>] <file>"
        
    'get command line
    commandline = Command()
    length = Len(commandline)
    
    'no arguments?
    If length = 0 Then
        MsgBox usage
        Exit Sub
    End If
    
    'get current path
    path = CurDir()
   
    'check for leading "
    If Left(commandline, 1) = Chr(34) Then
        'if so, remove the last charakter (")
        commandline = Mid(commandline, 2, length - 2)
    End If
    
    'leading +?
    If Left(commandline, 1) = "+" Then
        'remove +
        commandline = Mid(commandline, 2)
        start = InStr(commandline, " ")
        'get line number
        line = Trim(Mid(commandline, 1, start))
        ' get file name (without leading and trailing spaces)
        file = Trim(Mid(commandline, start + 1))
        If line = "" Or file = "" Then
            MsgBox usage
            Exit Sub
        End If
    Else
        'no leading +, just file name
        file = Trim(commandline)
    End If

    Set vim = CreateObject("Vim.Application")
    vim.SendKeys (":cd " & path & "<c-m>")
    vim.SendKeys (":e " & file & "<c-m>")
    If line <> "" Then vim.SendKeys (":" & line & "<c-m>")
    vim.SetForeground
End Sub
